/*
                          Visual FX Arexx Script
                           Written By J.L. White
                         (C)1997 Merlin's Software
*/

Options Results
address "IMAGEFX.1"
ScreenToFront
Undo Off
if exists("libs:flyer.library") then do
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	end
call Settings()
call open TempFile,"VFXIFX:TempDrawer/"FXNum".txt",R
line = readln(TempFile)
Quad1 = strip(line)
line = readln(TempFile)
Quad2 = strip(line)
line = readln(TempFile)
Quad3 = strip(line)
line = readln(TempFile)
Quad4 = strip(line)
call close (TempFile)
j=0
TFrames = Frames
if Field = 1 then TFrames = Frames*2
do i = 1 to Frames
	call open TempFile,"RAM:VFXNums",W
	call writeln TempFile,right(i,5,'0')
	call writeln TempFile,right(Frames,5,'0')
	call close TempFile
	f=0
	Redraw Off
	FieldSet = 0
	if Padding ~= -1 & i = 1 then call PadIt(1)
	call LoadB()
	call LoadA()
	j = j+ 1
	call DoIt()
	Redraw On
	call SaveIt()
		if Field = 1 then do
			Redraw Off
			FieldSet = 1
			call LoadB()
			call LoadA()
			j = j + 1
			call DoIt()
			Redraw On
			call SaveIt()
			end 
	if Padding ~= -1 & i = Frames then call PadIt(2)
	end
	if SaveType = 0 then do
		if Padding = -1 then
			call MakeIcon(SaveName,(Frames-10))
		else
			call MakeIcon(SaveName,(Padding+(Frames-10)))
		end
	Undo On
exit


PadIt:
arg PadNum
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
     	if PadNum = 1 then do
	   if IAType = 0 then do
		do Pad = Padding to 1 by -1
			LoadBuffer PicAName Force StartA-(Pad-1)
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	   if IAType = 1 then do
		LoadBuffer PicAName Force 1
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IAType = 2 then do
		LoadBuffer PicAName Force
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IAType = 3 then do
		do Pad = Padding to 1 by -1
			LoadBuffer PicAName""right(StartA-(Pad-1),3,'0') Force
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	end 
	else do
	   if IBType = 0 then do
		do Pad = 1 to Padding
			LoadBuffer PicBName Force StartB+Pad+Frames
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	   if IBType = 1 then do
		LoadBuffer PicBName Force 1
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IBType = 2 then do
		LoadBuffer PicBName Force
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IBType = 3 then do
		do Pad = 1 to Padding
			LoadBuffer PicBName""right(StartB+Pad+Frames),3,'0') Force
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	end
return


LoadA:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = TFrames then return
	if IAType = 0 then do
		LoadBuffer PicAName Force i+StartA
		end
	if IAType = 1 then do
		LoadBuffer PicAName Force 1
		end
	if IAType = 2 then do
		LoadBuffer PicAName Force
		end
	if IAType = 3 then do
		LoadBuffer PicAName""right(i+StartA,3,'0') Force
		end

return

LoadB:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = 1 then return
	if IBType = 0 then do
		LoadBuffer PicBName Force i+StartB
		end
	if IBType = 1 then do
		LoadBuffer PicBName Force 1
		end
	if IBType = 2 then do
		LoadBuffer PicBName Force
		end
	if IBType = 3 then do
		LoadBuffer PicBName""right(i+StartB,3,'0') Force
		end
	Swap
return


DoIt:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = TFrames then do
		Swap
		return
		end
	if j = 1 then return


	GetMain
	parse var result Name Width Height Blah

	if Quad1 = 1 then do
		A1 = 0
		B1 = 0
		end
	if Quad1 = 2 then do
		A2 = 0
		B2 = 0
		end
	if Quad1 = 3 then do
		A3 = 0
		B3 = 0
		end
	if Quad1 = 4 then do
		A4 = 0
		B4 = 0
		end


	if Quad2 = 1 then do
		A1 = Width/2
		B1 = 0
		end
	if Quad2 = 2 then do
		A2 = Width/2
		B2 = 0
		end
	if Quad2 = 3 then do
		A3 = Width/2
		B3 = 0
		end
	if Quad2 = 4 then do
		A4 = Width/2
		B4 = 0
		end

	if Quad3 = 1 then do
		A1 = 0
		B1 = Height/2
		end
	if Quad3 = 2 then do
		A2 = 0
		B2 = Height/2
		end
	if Quad3 = 3 then do
		A3 = 0
		B3 = Height/2
		end
	if Quad3 = 4 then do
		A4 = 0
		B4 = Height/2
		end

	if Quad4 = 1 then do
		A1 = Width/2
		B1 = Height/2
		end
	if Quad4 = 2 then do
		A2 = Width/2
		B2 = Height/2
		end
	if Quad4 = 3 then do
		A3 = Width/2
		B3 = Height/2
		end
	if Quad4 = 4 then do
		A4 = Width/2
		B4 = Height/2
		end




	Num = trunc(((j-1) * 4)/(TFrames-1))

	Num1 = trunc(((j-1) * 200)/((TFrames/2)-1))
	Num2 = Num1-100
	Num3 = Num1-200
	Num4 = Num1-300
	
	DrawStyle RubThrough
	if Num = 0 then do
		Blend Num1
		FilledBox A1 B1 Width/2 Height/2
		end
	if Num = 1 then do
		Blend 100
		FilledBox A1 B1 Width/2 Height/2
		Blend Num2
		FilledBox A2 B2 Width/2 Height/2
		end
	if Num = 2 then do
		Blend 100
		FilledBox A1 B1 Width/2 Height/2
		FilledBox A2 B2 Width/2 Height/2
		Blend Num3
		FilledBox A3 B3 Width/2 Height/2
		end
	if Num > 2 then do
		Blend 100
		FilledBox A1 B1 Width/2 Height/2
		FilledBox A2 B2 Width/2 Height/2
		FilledBox A3 B3 Width/2 Height/2
		Blend Num4
		FilledBox A4 B4 Width/2 Height/2
		end
	Blend 100
	DrawStyle Normal


return

SaveIt:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if SaveType = 0 then do
		call Switcher(TOSW)
		call Switcher(MDV1)

		Render Go
		if Field = 1 then
	        	call RecordAdd(SaveName,1,6,Compression)
		else
	        	call RecordAdd(SaveName,2,6,Compression)
		end

	if SaveType = 1 then do
		if Field = 1 then do
			f= f + 1
			if f = 1 then
				SaveBufferAs ILBM "VFXIFX:TempDrawer/PicA"
			if f = 2 then do
				GetMain
				parse var result Name Width Height Blah
				Scale Width Height/2
				Swap
				LoadBuffer "VFXIFX:TempDrawer/PicA" Force
				Scale Width Height/2
				Hook Interlace
				SaveBufferAs ILBM SaveName""right(i,3,'0')
				f = 0
				end
			end
		else do
			SaveBufferAs ILBM SaveName""right(i,3,'0')
			end	
		end
return


