/*
                          Visual FX Arexx Script
                           Written By J.L. White
                         (C)1997 Merlin's Software
*/

Options Results
address "IMAGEFX.1"
ScreenToFront
Undo Off
if exists("libs:flyer.library") then do
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	end
call Settings()
call open TempFile,"VFXIFX:TempDrawer/"FXNum".txt",R
line = readln(TempFile)
Feather = strip(line)
line = readln(TempFile)
FireType = strip(line)
line = readln(TempFile)
Style = strip(line)
line = readln(TempFile)
FireNum = strip(line)
line = readln(TempFile)
ZoomType = strip(line)
line = readln(TempFile)
CircleType = strip(line)
line = readln(TempFile)
XOff = strip(line)
line = readln(TempFile)
YOff = strip(line)
call close (TempFile)

j=0
TFrames = Frames
if Field = 1 then TFrames = Frames*2
do i = 1 to Frames
	call open TempFile,"RAM:VFXNums",W
	call writeln TempFile,right(i,5,'0')
	call writeln TempFile,right(Frames,5,'0')
	call close TempFile
	f=0
	Redraw Off
	FieldSet = 0
	if Padding ~= -1 & i = 1 then call PadIt(1)
	call LoadB()
	call LoadA()
	j = j+ 1
	call DoIt()
	Redraw On
	call SaveIt()
		if Field = 1 then do
			Redraw Off
			FieldSet = 1
			call LoadB()
			call LoadA()
			j = j + 1
			call DoIt()
			Redraw On
			call SaveIt()
			end 
	if Padding ~= -1 & i = Frames then call PadIt(2)
	end
	if SaveType = 0 then do
		if Padding = -1 then
			call MakeIcon(SaveName,(Frames-10))
		else
			call MakeIcon(SaveName,(Padding+(Frames-10)))
		end
	Undo On
exit



PadIt:
arg PadNum
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
     	if PadNum = 1 then do
	   if IAType = 0 then do
		do Pad = Padding to 1 by -1
			LoadBuffer PicAName Force StartA-(Pad-1)
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	   if IAType = 1 then do
		LoadBuffer PicAName Force 1
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IAType = 2 then do
		LoadBuffer PicAName Force
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IAType = 3 then do
		do Pad = Padding to 1 by -1
			LoadBuffer PicAName""right(StartA-(Pad-1),3,'0') Force
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	end 
	else do
	   if IBType = 0 then do
		do Pad = 1 to Padding
			LoadBuffer PicBName Force StartB+Pad+Frames
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	   if IBType = 1 then do
		LoadBuffer PicBName Force 1
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IBType = 2 then do
		LoadBuffer PicBName Force
		call Switcher(TOSW)
		call Switcher(MDV1)
		Render Go
        	call RecordAdd(SaveName,2*Padding,6,Compression)
		end
	   if IBType = 3 then do
		do Pad = 1 to Padding
			LoadBuffer PicBName""right(StartB+Pad+Frames),3,'0') Force
			call Switcher(TOSW)
			call Switcher(MDV1)
			Render Go
	        	call RecordAdd(SaveName,2,6,Compression)
			end
		end
	end
return

LoadA:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = TFrames then return
	if IAType = 0 then do
		LoadBuffer PicAName Force i+StartA
		end
	if IAType = 1 then do
		LoadBuffer PicAName Force 1
		end
	if IAType = 2 then do
		LoadBuffer PicAName Force
		end
	if IAType = 3 then do
		LoadBuffer PicAName""right(i+StartA,3,'0') Force
		end

return

LoadB:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = 1 then return
	if IBType = 0 then do
		LoadBuffer PicBName Force i+StartB
		end
	if IBType = 1 then do
		LoadBuffer PicBName Force 1
		end
	if IBType = 2 then do
		LoadBuffer PicBName Force
		end
	if IBType = 3 then do
		LoadBuffer PicBName""right(i+StartB,3,'0') Force
		end
	Swap
return


DoIt:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if j = TFrames then do
		Swap
		return
		end

	GetMain
	parse var result Name Width Height Blah

	if j = 1 then do
		HMiddle = Height/2
		WMiddle = Width/2
		xrad = 0
		yrad = 0
		xctr = XOff
		yctr = YOff
		if ZoomType = 1 then do
			xctr = WMiddle
			yctr = HMiddle
			end
		return
		end

	if ZoomType = 1 then Swap

	AlphaChannel Off
	Buffer2Alpha
	SwapAlpha
	Clearbuffer Force 0 0 0
	EdgeMode FeatherOut Feather

	if CircleType = 0 then do
		Num = (((j-1) * (Height - 10))/(TFrames-1))
		Num = trunc(Num)
		if ZoomType = 1 then Num = (Height-10)-Num
		FilledOval Width/2 Height/2 Num Num
		end
	else do

		if XOff <= WMiddle then do
			xrstp=(Width-XOff)/TFrames
			xstp=(WMiddle-XOff)/TFrames
			if ZoomType = 1 then xctr = xctr-xstp
			else xctr = xctr+xstp
			end
  		else do
			xrstp=XOff/TFrames
			xstp=(XOff-WMiddle)/TFrames
			if ZoomType = 1 then xctr = xctr+xstp
			else xctr = xctr-xstp
			end

		if YOff >= HMiddle then do
			yrstp=YOff/TFrames
			ystp=(HMiddle-YOff)/TFrames
			if ZoomType = 1 then yctr = yctr-ystp
			else yctr = yctr+ystp
			end
  		else do
			yrstp=(Height-YOff)/TFrames
			ystp=(YOff-HMiddle)/TFrames
			if ZoomType = 1 then yctr = yctr+ystp
			else yctr = yctr - ystp
			end
		xrad = (((j-1) * (495))/(TFrames-1))
		xctr = trunc(xctr)
		yctr = trunc(yctr)
		xrad = trunc(xrad)
		if ZoomType = 1 then do
			xrad = 495-xrad
			end
		FilledOval xctr yctr xrad xrad
		end

	EdgeMode Normal
	SwapAlpha
	AlphaChannel FRISKET
	Merge 100 Alpha
	AlphaChannel Off
	NewFireNum = (((j-1) * (100))/(TFrames-1))
	NewFireNum = trunc(NewFireNum)+5

	if Style = 0 then NewType = "Radial_Out"
	if Style = 1 then NewType = "Radial_In"
	if Style = 2 then do
		NewType = "Radial_In"
		NewFireNum = FireNum
		end
	if Style = 3 then do
		NewType = "Radial_Out"
		NewFireNum = FireNum
		end
	if CircleType = 0 then do
		if FireType = 0 then
			Hook Fire '9883516' '0' NewFireNum Width/2 Num Width/2 Height/2 '0' '50' '180' '0' '2' '1' Paint Wood NewType '100' '0' '20' '20' '0' '0' '0' '0' '0' '3'
		if FireType = 1 then
			Hook Fire '9883516' '0' NewFireNum Width/2 Num Width/2 Height/2 '0' '50' '180' '0' '2' '1' Paint Gas NewType '100' '0' '20' '20' '0' '0' '0' '0' '0' '3'
		end
	else do
		if FireType = 0 then
			Hook Fire '9883516' '0' NewFireNum Width/2 xrad xctr yctr '0' '50' '180' '0' '2' '1' Paint Wood NewType '100' '0' '20' '20' '0' '0' '0' '0' '0' '3'
		if FireType = 1 then
			Hook Fire '9883516' '0' NewFireNum Width/2 xrad xctr yctr '0' '50' '180' '0' '2' '1' Paint Gas NewType '100' '0' '20' '20' '0' '0' '0' '0' '0' '3'
		end
return

SaveIt:
	if (POS('FLY_1',SHOW('Ports')) = 0) then do
		Undo On
		exit
		end
	if SaveType = 0 then do
		call Switcher(TOSW)
		call Switcher(MDV1)

		Render Go
		if Field = 1 then
	        	call RecordAdd(SaveName,1,6,Compression)
		else
	        	call RecordAdd(SaveName,2,6,Compression)
		end

	if SaveType = 1 then do
		if Field = 1 then do
			f= f + 1
			if f = 1 then
				SaveBufferAs ILBM "VFXIFX:TempDrawer/PicA"
			if f = 2 then do
				GetMain
				parse var result Name Width Height Blah
				Scale Width Height/2
				Swap
				LoadBuffer "VFXIFX:TempDrawer/PicA" Force
				Scale Width Height/2
				Hook Interlace
				SaveBufferAs ILBM SaveName""right(i,3,'0')
				f = 0
				end
			end
		else do
			SaveBufferAs ILBM SaveName""right(i,3,'0')
			end	
		end

return


